<?php if(!defined('SECURE')) {die("OMG HAXXOR!");} // Verifies execution access
// ===================================================================
// Soder's Pastebin
// Copyright (C) 2007-2008  Fredrik Sderlund

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.

// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>. 
// ===================================================================

function WriteForm($D = array('start' => '1')) {
    global $Syntax_list, $Syntax_list_popular;
    $form['name']           = get_rand_id(6, true);
    $form['description']    = get_rand_id(6, true);
    $form['syntax']         = get_rand_id(6, true);
    $form['start']          = get_rand_id(6, true);
    $form['code']           = get_rand_id(6, true);
    $form['error_check']    = get_rand_id(6, true);

    $_SESSION['form'] = $form;
    $_SESSION['secret_code'] = 1;
    
    echo '    <iframe src="session_keeper.php?' . session_id() . '" class="session_keeper" height="0" width="0"></iframe>    
    <form method="post" action="./' . $_GET['p'] . '" name="paste" id="codeform">
        <fieldset id="field1"><Legend style="display:none"></Legend>            
            <input type="hidden" name="session" value="' . session_id() . '">
            <input type="hidden" name="old_id"  value="' . encrypt($D['id']) . '">
            <input type="hidden" name="' . $form['error_check'] . '" value="pass">
            <label for="' . $form['name'] . '" style="display:block">Your name</label><span><!-- The span is for fixing an IE7 bug :( --><input id="' . $form['name'] . '" tabindex="1" maxlength="30" name="' . $form['name'] . '" size="20" value="' . htmlspecialchars(decrypt($_COOKIE['name'])) . '" style="width: 100%; margin-bottom: 10px; margin-left:0px"></span>
            <label for="' . $form['syntax'] . '" style="display:block">Syntax</label>
            <select name="' . $form['syntax'] . '" id="' . $form['syntax'] . '" style="width: 100%; margin-bottom:20px" tabindex="2">';
            foreach ($Syntax_list as $syntax=>$name){
                if ($syntax == $D['language']) { $opt = ' selected="selected"'; }
                // Popular syntax is written in bold/italic.
                if (in_array($syntax, $Syntax_list_popular)) { $opt .= ' style="font-weight: bold; font-style: italic;"'; }                 
                echo "\n                <option value=\"$syntax\"$opt>$name</option>";
                $opt = "";
            }
            echo'
            </select>                
            <label for="' . $form['start'] . '">Start at line number</label>
            <input tabindex="3" maxlength="4" value="'. $D['start'] . '" id="' . $form['start'] . '" name="' . $form['start'] . '" size="6" style="margin-left:3px;">
            <div style="margin-top: 10px;">
                <label for="' . $form['description'] . '">Description</label><br>
                <textarea id="' . $form['description'] . '" name="' . $form['description'] . '" cols="20" rows="4" style="width: 100%;" tabindex="4">' . htmlspecialchars($D['description']) . '</textarea>
            </div>
        </fieldset>
        <fieldset id="field2"><Legend style="display:none"></Legend>
            <label for="' . $form['code'] . '" style="display:block">Code</label>
            <textarea tabindex="5" cols="10000" rows="25" class="code_field" id="' . $form['code'] . '" name="' . $form['code'] . '">' . htmlspecialchars($D['text']) . '</textarea>                
        </fieldset>
        <fieldset id="field3"><Legend style="display:none"></Legend>
            <input tabindex="6" name="Send" value="PASTE" type="Submit" class="Send" >
        </fieldset>
    </form>';
}

function get_rand_id($len = 16, $az = false) {
    if ($az === true) {
        $base = 'abcdefghijklmnopqrstuvwxyz';
    }
    else {
        $base = 'abcdefghijklmnopqrstuvwxyz0123456789';
    }
    $max = strlen($base) - 1;
    $rand_id = '';
    mt_srand((double)microtime() * 1000000);
    while (strlen($rand_id) < $len + 1) {
        $rand_id .= $base{mt_rand(0, $max)};
    }
    return $rand_id;
}

function encrypt($value){
   if(!$value){return false;}
   $key = $config['Main']['salt'];
   $text = $value;
   $iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB);
   $iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);
   $crypttext = mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $key, $text, MCRYPT_MODE_ECB, $iv);
   return trim(base64_encode($crypttext));
}

function decrypt($value){
   if(!$value){return false;}
   $key = $config['Main']['salt'];
   $crypttext = base64_decode($value);
   $iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB);
   $iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);
   $decrypttext = mcrypt_decrypt(MCRYPT_RIJNDAEL_256, $key, $crypttext, MCRYPT_MODE_ECB, $iv);
   return trim($decrypttext);
}

function stripslashes_deep($value){
    $value = is_array($value) ?
	array_map('stripslashes_deep', $value) :
	stripslashes($value);
	return $value;
}

$Syntax_list = array(
    'text'=>'None',
    'actionscript'=>'ActionScript',
    'ada'=>'Ada',
    'apache'=>'Apache Log File',
    'applescript'=>'AppleScript',
    'asm'=>'ASM (NASM based)',
    'asp'=>'ASP',
    'bash'=>'Bash',
    'c'=>'C',
    'c_mac'=>'C for Macs',
    'caddcl'=>'CAD DCL',
    'cadlisp'=>'CAD Lisp',
    'cpp'=>'C++',
    'csharp'=>'C#',
    'cfm'=>'ColdFusion',
    'css'=>'CSS',
    'd'=>'D',
    'delphi'=>'Delphi',
    'diff'=>'Diff',
    'dos'=>'DOS',
    'eiffel'=>'Eiffel',
    'fortran'=>'Fortran',
    'freebasic'=>'FreeBasic',
    'gml'=>'Game Maker',
    'html4strict'=>'HTML',
    'ini'=>'INI file',
    'java'=>'Java',
    'javascript'=>'Javascript',
    'latex'=>'LaTeX',
    'lisp'=>'Lisp',
    'lua'=>'Lua',
    'matlab'=>'MatLab',
    'mpasm'=>'MPASM',
    'mysql'=>'MySQL',
    'nsis'=>'NullSoft Installer',
    'objc'=>'Objective C',
    'ocaml'=>'OCaml',
    'oobas'=>'Openoffice.org BASIC',
    'oracle8'=>'Oracle 8',
    'pascal'=>'Pascal',
    'perl'=>'Perl',
    'php'=>'PHP',
    'python'=>'Python',
    'qbasic'=>'QBasic/QuickBASIC',
    'robots'=>'Robots',
    'ruby'=>'Ruby',
    'scheme'=>'Scheme',
    'smarty'=>'Smarty',
    'sql'=>'SQL',
    'tcl'=>'TCL',
    'vb'=>'VisualBasic',
    'vbnet'=>'VB.NET',
    'visualfoxpro'=>'VisualFoxPro',
    'xml'=>'XML',
);

$Syntax_list_popular = array(
    'text','bash', 'c', 'cpp', 'html4strict',
    'java','javascript','php','perl', 'python', 'ruby', 'lua');

function detect_ie() {
    if (isset($_SERVER['HTTP_USER_AGENT']) && 
    (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false))
        return true;
    else
        return false;
}

function tab($nr = 1) {
    for ($i=0; $i < $nr; $i++) { 
        $out .= '    ';
    }
    return $out;
}

// Returns a tree of relations between pastes
function GetTree($id) {
    
    // Find the rot of the tree.
    function find_rot($Child){
        GLOBAL $db_link;
        $db_query = 'SELECT `parent` FROM `list` WHERE `id` = \''. $Child .'\''; 
        //$db_query = 'SELECT `parent` FROM `tree` WHERE `child` = \''. $Child .'\''; 
        $db_result = mysql_query($db_query, $db_link);
        if (!$db_result) {error_report('Query failed: ' . mysql_error() , 81);}
        
        $parent = mysql_fetch_row($db_result);
        if ($parent[0] != ''){
            return find_rot($parent[0]);
        } 
        else {                  
            return $Child;
        }
    }
    
    /* The preorder algorithm
    preorder(node)
        print node.value
        if node.left ? null then preorder(node.left)
        if node.right ? null then preorder(node.right)
    */
    
    // Returns a tree.
    function prerorder($Node, $id, $depth = 0, $tree = ''){
        GLOBAL $db_link;
        
        //Write node
        if ($Node['id'] == $id) {
            $tree .= tab($depth+2).'<b>'. $Node['name'] ."</b>\n";
            $tree .= tab($depth+2).'(' . $Node['date'] . ', ' . $Node['time']. ") (Current)\n";
        }
        else{
            $tree .= tab($depth+2).'<a href="/'. $Node['id'] .'">'. $Node['name'] ."</a>\n";
            $tree .= tab($depth+2).'(' . $Node['date'] . ', ' . $Node['time']. ")\n";
            if (!detect_ie()) {
                $tree .= tab($depth+2).'<a href="/'. $id .'/'. $Node['id'] .'">Compare</a>'."\n";
            }
        }
        
        if ($depth > 300) { // we don't want to smash the stack :) ...just to be sure
            return $tree;
        }
        
        $db_query = 'SELECT * FROM `list` WHERE `parent` = \''. $Node['id'] .'\' ORDER BY `date` ASC , `time` ASC ';
        $db_result = mysql_query($db_query, $db_link);
        if (!$db_result) {error_report('Query failed: ' . mysql_error() , 82);}
        
        if (mysql_num_rows($db_result) > 0) {
            $tree .= tab($depth+2)."<ul>\n";
            while($child = mysql_fetch_assoc($db_result)){
                $tree .= tab($depth+3)."<li>\n";
                $tree  = prerorder($child, $id, $depth+2, $tree);
                $tree .= tab($depth+3)."</li>\n";
            }
            $tree .= tab($depth+2)."</ul>\n";
        }
        //echo $depth;
        return $tree;
    }
    
    $Rot = find_rot($id);
    
    // Get db entery for $Rot
    GLOBAL $db_link;    
    $db_query = 'SELECT * FROM `list` WHERE `id` = \''. $Rot .'\'';
    $db_result = mysql_query($db_query, $db_link);
    if (!$db_result) {error_report('Query failed: ' . mysql_error() , 82);}   
    $Rot = mysql_fetch_assoc($db_result); 
    
    // Create tree
    $tree  =  "\n".tab(1).'<div id="tree">'."\n";
    $tree .=  tab(2)."<ul id=\"treelist\">\n".tab(3)."<li>\n";
    $tree .=  prerorder($Rot, $id, 2);
    $tree .=  tab(3)."</li>\n".tab(2)."</ul>";
    $tree .=  "\n".tab(1).'</div>'."\n";
    
    // return tree if bigger than one node
    $check = explode("\n", $tree);
    $lines = count($check);
    if ($lines > 10) {
        return $tree;
    }
    else {
        return false;
    }
}

// Prints page start.
function WriteStart($title = "", $CSS = "") {
    
     // makes the title
    if ($title == '')   {$title = 'Soder\'s Pastebin';}
    else                {$title = 'Soder\'s Pastebin : ' . $title;}
    
    // wrap the CSS in <style> tags
    if ($CSS !== '') {
        $CSS = '    <style type="text/css">'."\n".'    <!--'."\n". $CSS .'    -->'."\n    </style>";    
    }
    
    echo '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <link rel="shortcut icon" href="/paste_plain.png">
    <base href="http://' . $_SERVER['HTTP_HOST'] . '/" >
    <title>
        ' . $title . '
    </title>
    <script type="text/javascript" src="jquery-1.2.6.min.js"></script>
    <link rel="stylesheet" href="style.css" type="text/css" media="screen" title="Stylesheet" charset="utf-8">
'. $CSS ;
    if (detect_ie()) { echo '
    <style type="text/css">
        /* MS IE7 Bug fixes */
        input {
            margin-left:-20px;
            margin-right:-20px;
            padding-left:-20px;        
        }
        select {
            margin-bottom:-20px;
        }
    </style>';
    }
    echo ' 
</head>
<body>
    <div id="Main_header">
        <div id="logo"><A href="./"><img src="logo3.png" width="339" height="44" border="0" alt="Soder\'s Pastebin"></a></div>
        <div id="Menu"><A href="./">New paste</a> | <A href="./about">About</A></div>'."\n";
        if (detect_ie()) {
            //echo '        <div id="fx_big"><a href="http://www.spreadfirefox.com/node&id=0&t=309"><img border="0" alt="Firefox 3" title="Firefox 3" src="http://sfx-images.mozilla.org/affiliates/Buttons/firefox3/468x60.png"/></a></div>'."\n";
        }        
    echo '    </div>      
';
}

// Prints page end.
function WriteEnd() {
    echo "\n".'    <div style="display: none;"><a href="http://www.auditmypc.com/freescan/anti-spam-food.html" target="_blank">Spam bot food</a></div>';
	echo "\n</body>\n</html>";
	
	// Stopp timer
	GLOBAL $starttime;
	
    $timeparts = explode(" ",microtime());
    $endtime = $timeparts[1].substr($timeparts[0],1);
    $total_length = $endtime-$starttime;
    $total_length = round($total_length,6);
    
    // Write time
    echo "\n\n<!--\n\n    Created in $total_length seconds.";
    echo "\n\n-->";	
}

function WriteShadow() {
    echo '    <div id="shadow"></div>'."\n";
    /*if (detect_ie()) {
        echo '    <script type="text/javascript">
        $(document).ready(function() {
            $(".IE_Message").html("<div class=\".IE_Message_link\"><p>A message for you!</p></div>");
            
            $(".IE_Message_link").hover(function () {
                $(".IE_Message_link").css({ "color":"#FFFFFF", "cursor":"pointer"});
            }, function () {
                $(".IE_Message_link").css({ "color":"#e55b2b", "cursor":"default"});
            });
        });
        </script>';
        
        echo '<span class="IE_Message"></span>';
    }*/
}
?>